<?php
/**
 * @copyright   Copyright (C) 2005 - 2013 Michael Richey. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */
defined('_JEXEC') or die;
if(!class_exists('TagParser')) require_once('tagparser.php');
class plgContentAgeOf extends JPlugin {
	public function onContentPrepare($context, &$article, &$params, $page = 0) {		
		if ($context == 'com_finder.indexer' || !strpos($article->text, '{/ageof}')) return true; // good reasons to exit early
                $this->loadLanguage();               
		$tagparser = new TagParser('ageof');
                $tagparser->parse($article->text);
                $defaultlength=$this->params->get('length',2);
                foreach(array('pastfuture'=>1,'pastprefix'=>'','pastsuffix'=>'','futureprefix'=>'','futuresuffix'=>'') as $param=>$default) ${'default'.$param}=$this->params->get($param,$default);
                foreach($tagparser->tags as $tag) {
                    $process = true;
                    $output = '';
                    
                    $now=new DateTime('now');
                    $before=$tag->getParam('before',false);
                    if($before !== false) {
                        $before = new DateTime($before);
                        if($now >= $before) $process=false;
                    }                    
                    $after=$tag->getParam('after',false);
                    if($after !== false) {
                        $after = new DateTime($after);
                        if($now <= $after) $process=false;
                    }
                    
                    if($process) {
                        $interval = $this->_getAge(is_numeric($tag->content)?date('c',$tag->content):$tag->content);
                        $format = $this->_format($interval,$tag->getParam('length',$defaultlength));
                        if(count($format) > 1) {
                            $last = array_pop($format);
                            $format=implode(', ',$format).JText::_('PLG_CONTENT_AGEOF_AND').$last;
                        } else {
                            $format = $format[0];
                        }
                        if($interval->invert) {
                            $prefix= $tag->getParam('pastprefix',$defaultpastprefix);
                            $suffix=($tag->getParam('pastfuture',$defaultpastfuture)?' '.JText::_('PLG_CONTENT_AGEOF_AGO'):'').$tag->getParam('pastsuffix',$defaultpastsuffix);
                        } else {
                            $prefix= $tag->getParam('futureprefix',$defaultfutureprefix);
                            $suffix=($tag->getParam('pastfuture',$defaultpastfuture)?' '.JText::_('PLG_CONTENT_AGEOF_FROMNOW'):'').$tag->getParam('futuresuffix',$defaultfuturesuffix);
                        }
                        $output = $prefix.$interval->format($format).$suffix;
                    }
                    $article->text = $tag->replace($article->text,$output);
                }
	}
        private function _getAge($datestring) {
            $date = new DateTime($datestring);
            $now = new DateTime('now');
            return $now->diff($date); 
        }
        private function _format($interval,$length) { 
            $doPlural = function($count,$string){return 'PLG_CONTENT_AGEOF_'.($count>1?$string.'S':$string);}; 
            $format = array(); 
            foreach(array('y'=>'YEAR','m'=>'MONTH','d'=>'DAY','h'=>'HOUR','i'=>'MINUTE') as $key=>$value) {
                if($interval->$key !== 0) $format[] = '%'.$key.' '.JText::_($doPlural($interval->$key, $value));
            }
            if($interval->s !== 0) { 
                if(!count($format)) return array(JText::_('PLG_CONTENT_AGEOF_LESSTHANMINUTE')); 
            } else { 
                $format[] = "%s ".JText::_($doPlural($interval->s, 'SECOND'));
            } 
            $format = array_chunk($format,$length);
            return $format[0]; 
        }
}
